#include <Servo.h> 
#include <Wire.h>
const int STEERING_PIN_1 = 6;
const int STEERING_PIN_2 = 7;
const int FORWARD_PIN_1 = 3;
const int FORWARD_PIN_2 = 4;
const int FORWARD_LIGHTS = 13;
const int REVERSE_LIGHTS = 12;
const int SERVO_PIN = 5;
const int SERVO_SCAN = 55;
const int SCAN_WAIT = 1;
int old_scan_time;
boolean servo_direction = false;
int oldTurnTime = 0;
boolean turn = false;
int turn_time = 300; //m
int DETECTION_DISTANCE = 100;
byte in_Bytes[4];
Servo dServo;
unsigned long oldTime;
unsigned long oldReadTime = millis();
int reading = 0;
int dist;
int pos = 85;
int posC = 85;
boolean writeData = true;
boolean autoGo = false;
void setup(){
  pinMode(STEERING_PIN_1,OUTPUT);
  pinMode(STEERING_PIN_2,OUTPUT);
  pinMode(FORWARD_PIN_1,OUTPUT);
  pinMode(FORWARD_PIN_2,OUTPUT);
  pinMode(FORWARD_LIGHTS,OUTPUT);
  pinMode(REVERSE_LIGHTS,OUTPUT);
  Serial.begin(19200);
  dServo.attach(SERVO_PIN);
  dServo.write(pos);
  Wire.begin();
  oldTime = millis();
}
void loop(){
  while (Serial.available()>0)
  {
    for(int i = 0; i<4; i++){
      in_Bytes[i]=in_Bytes[i+1];
    }
    in_Bytes[3]=Serial.read();
  }
  updateDist();
  //turning
  if(in_Bytes[0]=='s'&&in_Bytes[1]=='x'){  
    if(in_Bytes[2]=='l'){
      int i = in_Bytes[3];
      analogWrite(STEERING_PIN_1,i);
      digitalWrite(STEERING_PIN_2,LOW);
    }else
    if(in_Bytes[2]=='r'){
      int i = in_Bytes[3];
      digitalWrite(STEERING_PIN_2,HIGH);
      analogWrite(STEERING_PIN_1,255-i);
    }else
    if(in_Bytes[2]=='n'){
      digitalWrite(STEERING_PIN_2,HIGH);
      digitalWrite(STEERING_PIN_1,HIGH);
    }
    clearData();
  }
  //forwards
  if(in_Bytes[0]=='s'&&in_Bytes[1]=='y'){
    if(in_Bytes[2]=='f'){
      int i = in_Bytes[3];
      digitalWrite(FORWARD_PIN_2,LOW);
      analogWrite(FORWARD_PIN_1,i);
      digitalWrite(REVERSE_LIGHTS,LOW);
    }else
    if(in_Bytes[2]=='r'){
      int i = in_Bytes[3];
      digitalWrite(FORWARD_PIN_2,HIGH);
      analogWrite(FORWARD_PIN_1,255-i);
      digitalWrite(REVERSE_LIGHTS,HIGH);
    }else
    if(in_Bytes[2]=='n'){
      digitalWrite(FORWARD_PIN_2,HIGH);
      digitalWrite(FORWARD_PIN_1,HIGH);
      digitalWrite(REVERSE_LIGHTS,LOW);
    }
    clearData();
  }
  if(in_Bytes[0]=='s'&&in_Bytes[1]=='l'){
    int state = 0;
    if(in_Bytes[3]=='o'){
      state = 1;
    }
    if(in_Bytes[2]=='f'){
      digitalWrite(FORWARD_LIGHTS,state);
    }
    clearData();
  }
  //front servo
  if(in_Bytes[0]=='s'&&in_Bytes[1]=='s'){
    pos = in_Bytes[3];
    if(in_Bytes[2]=='f'){
      dServo.write(pos);
      clearData();
    }
  }
  if(in_Bytes[0]=='s'&&in_Bytes[1]=='a'){
    autoGo = !autoGo;
     if(autoGo){
       digitalWrite(FORWARD_PIN_2,LOW);
       analogWrite(FORWARD_PIN_1,120);
     }else{
      digitalWrite(FORWARD_PIN_2,HIGH);
      digitalWrite(FORWARD_PIN_1,HIGH);
     } 
    clearData();
  }
  if(autoGo){
    servoScan();
    if((millis()-oldReadTime)>30){
     if(dist<60&&!turn){
       turn = true;
       oldTurnTime = millis();
       if(pos<posC){
       digitalWrite(STEERING_PIN_2,HIGH);
       analogWrite(STEERING_PIN_1,0);
       }else{
       digitalWrite(STEERING_PIN_1,HIGH);
       analogWrite(STEERING_PIN_2,0);  
       }
     }
     oldReadTime = millis(); 
    }
    if((millis()-oldTurnTime)>turn_time&&turn){
      digitalWrite(STEERING_PIN_2,HIGH);
      digitalWrite(STEERING_PIN_1,HIGH);
      turn = false;
    }
  }  
}
void clearData(){
  for(int i=0; i<3; i++){
    in_Bytes[i]=0;
  }
}
void servoScan(){
  if((millis()-old_scan_time)>SCAN_WAIT){
  if(!servo_direction){
    //moving left
    if(pos>(posC-SERVO_SCAN)){
      pos--;
    }else{
      servo_direction = true;  
    }
  }else{
    //moving right
    if(pos<(posC+SERVO_SCAN)){
      pos++;                 
    }else{
      servo_direction = false;
    }
  }
  dServo.write(pos);
  old_scan_time = millis();
  }
}
void updateDist(){
    // step 1: instruct sensor to read echoes
    if(writeData){
  Wire.beginTransmission(112);
  Wire.write(byte(0x00));
  Wire.write(byte(0x51));
  Wire.endTransmission();
  writeData = false;
    }
  if((millis()-oldTime)>70&&!writeData){
    oldTime = millis();
    Wire.beginTransmission(112);
    Wire.write(byte(0x02));
    Wire.endTransmission();
    Wire.requestFrom(112, 2);
  }
  // step 5: receive reading from sensor
  if(2 <= Wire.available()&&writeData==false)    // if two bytes were received
  {
    reading = Wire.read();  // receive high byte (overwrites previous reading)
    reading = reading << 8;    // shift high byte to be high 8 bits
    reading |= Wire.read(); // receive low byte as lower 8 bits
    dist = reading;
    writeData = true;
  }
}
